package com.bzd.web.controller.jkgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.jkgl.SJkglGyhyPthyContracttemplateinfoService;

import java.util.List;

/**
*
* 平台合约模板信息表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "jkgl/sjkglgyhypthycontracttemplateinfo")
public class SJkglGyhyPthyContracttemplateinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "jkgl";

    @Autowired
    private SJkglGyhyPthyContracttemplateinfoService sJkglGyhyPthyContracttemplateinfoService;

    /**
    * 平台合约模板信息表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("jkgl:jk:view")
    @GetMapping("/sJkglGyhyPthyContracttemplateinfoAdd")
    public String add() {
        return prefix + "/SJkglGyhyPthyContracttemplateinfoAdd";
    }

    /**
    * 平台合约模板信息表 新增
    *
    * @return
    */
    @Log(title = "平台合约模板信息表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sJkglGyhyPthyContracttemplateinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sJkglGyhyPthyContracttemplateinfoService.addSJkglGyhyPthyContracttemplateinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 平台合约模板信息表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("jkgl:jk:view")
    @GetMapping("/sJkglGyhyPthyContracttemplateinfoView")
    public String sjkglgyhypthycontracttemplateinfoListView() {
        return prefix + "/SJkglGyhyPthyContracttemplateinfoList";
    }

    /**
    * 平台合约模板信息表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:sJkglGyhyPthyContracttemplateinfoList")
    @PostMapping("/sJkglGyhyPthyContracttemplateinfoList")
    @ResponseBody
    public TableDataInfo sjkglgyhypthycontracttemplateinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sJkglGyhyPthyContracttemplateinfoService.findSJkglGyhyPthyContracttemplateinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 平台合约模板信息表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:remove")
    @Log(title = "平台合约模板信息表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sJkglGyhyPthyContracttemplateinfoRemove")
    @ResponseBody
    public AjaxResult sjkglgyhypthycontracttemplateinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sJkglGyhyPthyContracttemplateinfoService.SJkglGyhyPthyContracttemplateinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 平台合约模板信息表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:edit")
    @GetMapping("/sJkglGyhyPthyContracttemplateinfoEdit/{id}")
    public String sjkglgyhypthycontracttemplateinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sJkglGyhyPthyContracttemplateinfoService.findSJkglGyhyPthyContracttemplateinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sjkglgyhypthycontracttemplateinfoPageEdit";
        }
        return prefix+ "/sjkglgyhypthycontracttemplateinfoEdit";
    }

    /**
    * 平台合约模板信息表保存修改的数据
    */
    @RequiresPermissions("jkgl:jk:edit")
    @Log(title = "平台合约模板信息表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sJkglGyhyPthyContracttemplateinfoEdit")
    @ResponseBody
    public AjaxResult sjkglgyhypthycontracttemplateinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sJkglGyhyPthyContracttemplateinfoService.updateSJkglGyhyPthyContracttemplateinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sjkglgyhypthycontracttemplateinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sjkglgyhypthycontracttemplateinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
